/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86.decoder;

import static ru.ispras.microtesk.model.x86.TypeDefs.*;

import ru.ispras.microtesk.decoder.DecoderItem;
import ru.ispras.microtesk.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.api.data.Type;
import ru.ispras.microtesk.model.x86.op.PUSH_RSEG;
import ru.ispras.microtesk.model.x86.mode.RSEG16;

/**
 * The {@code DecoderPUSH_RSEG} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderPUSH_RSEG extends DecoderItem {
  private static DecoderPUSH_RSEG instance = null;

  public static DecoderPUSH_RSEG get() {
    if (null == instance) {
      instance = new DecoderPUSH_RSEG();
    }
    return instance;
  }

  private DecoderPUSH_RSEG() {
    super(
        9,
        false,
        null,
        null
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    RSEG16 src = null;

    if (!matchNextOpc(image, BitVector.valueOf("000", 2, 3))) {
      return null;
    }

    src = (RSEG16) readNextPrimitive(image, DecoderRSEG16.get());
    if (null == src) {
      return null;
    }

    if (!matchNextOpc(image, BitVector.valueOf("110", 2, 3))) {
      return null;
    }

    return newResult(new PUSH_RSEG(src));
  }
}
