/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86.decoder;

import static ru.ispras.microtesk.model.x86.TypeDefs.*;

import ru.ispras.microtesk.decoder.DecoderItem;
import ru.ispras.microtesk.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.api.data.Type;
import ru.ispras.microtesk.model.x86.op.SBB_R8R8;
import ru.ispras.microtesk.model.x86.mode.R8;

/**
 * The {@code DecoderSBB_R8R8} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderSBB_R8R8 extends DecoderItem {
  private static DecoderSBB_R8R8 instance = null;

  public static DecoderSBB_R8R8 get() {
    if (null == instance) {
      instance = new DecoderSBB_R8R8();
    }
    return instance;
  }

  private DecoderSBB_R8R8() {
    super(
        16,
        true,
        "0001101011000000",
        "1111111111000000"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    R8 op1 = null;
    R8 op2 = null;

    if (!matchNextOpc(image, BitVector.valueOf("0001101011", 2, 10))) {
      return null;
    }

    op1 = (R8) readNextPrimitive(image, DecoderR8.get());
    if (null == op1) {
      return null;
    }

    op2 = (R8) readNextPrimitive(image, DecoderR8.get());
    if (null == op2) {
      return null;
    }

    return newResult(new SBB_R8R8(op1, op2));
  }
}
